import React from 'react';
declare const _default: {
    component: React.FunctionComponent<import("../../../../src").XAxisProps>;
    argTypes: {
        stroke: {
            control: {
                type: string;
            };
        };
    };
};
export default _default;
export declare const Simple: {
    render: (args: Record<string, any>) => JSX.Element;
    args: {
        data: {
            name: string;
            uv: number;
            pv: number;
            amt: number;
        }[];
    };
};
export declare const DoubleLine: {
    args: {
        data: {
            name: string;
            uv: number;
            pv: number;
            amt: number;
        }[];
        secondLine: JSX.Element;
    };
    render: (args: Record<string, any>) => JSX.Element;
};
export declare const StringTypeData: {
    args: {
        data: {
            name: string;
            uv: number;
            pv: number;
            amt: number;
        }[];
    };
    render: (args: Record<string, any>) => JSX.Element;
};
export declare const NumberTypeData: {
    args: {
        data: {
            x: number;
            y: number;
            value: number;
        }[];
        dataKey: string;
        type: string;
        lineDataKey: string;
    };
    render: (args: Record<string, any>) => JSX.Element;
};
export declare const TimestampTypeData: {
    args: {
        data: {
            time: number;
            value: number;
        }[];
        dataKey: string;
        domain: string[];
        type: string;
        lineDataKey: string;
    };
    render: (args: Record<string, any>) => JSX.Element;
};
export declare const DateTypeData: {
    args: {
        data: {
            x: Date;
            y: number;
        }[];
        dataKey: string;
        lineDataKey: string;
    };
    render: (args: Record<string, any>) => JSX.Element;
};
export declare const TickFormatterWithTimestamp: {
    args: {
        data: {
            time: number;
            value: number;
        }[];
        dataKey: string;
        domain: string[];
        scale: string;
        type: string;
        lineDataKey: string;
        tickFormatter: (value: number) => string;
    };
    render: (args: Record<string, any>) => JSX.Element;
};
export declare const TickFormatterWithRotation: {
    args: {
        data: {
            name: string;
            uv: number;
            pv: number;
            amt: number;
        }[];
        tickMargin: number;
        angle: number;
    };
    parameters: {
        controls: {
            include: string[];
        };
    };
    render: (args: Record<string, any>) => JSX.Element;
};
export declare const TimestampTypeDataScaleTime: {
    args: {
        data: {
            time: number;
            value: number;
        }[];
        dataKey: string;
        domain: string[];
        scale: string;
        type: string;
        lineDataKey: string;
    };
    render: (args: Record<string, any>) => JSX.Element;
};
export declare const NumberTypeDataWithCustomDomain: {
    args: {
        data: {
            x: number;
            y: number;
            value: number;
        }[];
        dataKey: string;
        domain: number[];
        type: string;
        lineDataKey: string;
        allowDataOverflow: boolean;
    };
    parameters: {
        controls: {
            include: string[];
        };
    };
    render: (args: Record<string, any>) => JSX.Element;
};
export declare const NumberTypeDataAllowDataOverflow: {
    args: {
        data: {
            x: number;
            y: number;
            value: number;
        }[];
        dataKey: string;
        domain: number[];
        type: string;
        lineDataKey: string;
        allowDataOverflow: boolean;
    };
    parameters: {
        controls: {
            include: string[];
        };
    };
    render: (args: Record<string, any>) => JSX.Element;
};
export declare const CustomizedTicks: {
    args: {
        data: {
            name: string;
            uv: number;
            pv: number;
            amt: number;
        }[];
        tick: (props: {
            x: number;
            y: number;
            payload: {
                value: string;
            };
        }) => JSX.Element;
    };
    parameters: {
        controls: {
            include: string[];
        };
    };
    render: (args: Record<string, any>) => JSX.Element;
};
export declare const CustomizedTickLabel: {
    args: {
        data: {
            name: string;
            uv: number;
            pv: number;
            amt: number;
        }[];
        label: {
            value: string;
            position: string;
            offset: number;
        };
    };
    render: (args: Record<string, any>) => JSX.Element;
};
